<script>
import { REFER } from "../popover-select/api/index";

export default {
  name: "PopoverSelectV2",
  props: {
    // v-model
    value: {
      type: [Array, String],
      require: true,
    },
    // 参照类型 ，对应后端
    referName: {
      type: String,
      require: true,
    },
    // 作为 value 唯一标识的键名，绑定值
    valueKey: {
      type: String,
      dafault: () => {
        return "code";
      },
    },
    // 默认查询参数
    queryParams: {
      type: Function,
      default: () => {},
    },
    // 需映射源数据
    source: {
      type: Object,
      default: () => ({}),
    },
    // 参照内外映射
    dataMapping: {
      type: Object,
      default: () => ({}),
    },
  },
  components: {},
  data() {
    return {
      size: "mini",
      width: "50%",
      page: { pageNum: 1, pageSize: 10, total: 0 },
      visible: false,
      loading: false,
      model: {
        search: "",
        isPage: true,
      },
      data: [],
      selectData: [],
    };
  },
  computed: {
    innerValue: {
      get() {
        return this.value;
      },
      set(value) {
        this.$emit("input", value);
      },
    },
    TableColumns() {
      const { referName } = this.$props;
      return require(`../popover-select/components/${referName}`).default.filter(
        (document) => document.key
      );
    },
  },
  watch: {
    innerValue: {
      handler: function (newValue) {
        if (!newValue) {
          const {
            $props: { source, dataMapping },
          } = this;
          for (let key in dataMapping) {
            source[key] = undefined;
          }
          this.$emit("update:source", source);
        }
      },
    },
  },
  methods: {
    // open dialog
    async open() {
      this.visible = true;
      await this.useReset();
    },
    // hide dialog
    async hide() {
      this.visible = false;
    },
    // fetch list
    async fetchList(prop, page) {
      try {
        // try
        this.loading = true;
        const { pageNum, pageSize } = page;
        const { referName: type, source, queryParams } = this.$props;
        const { code, rows, total } = await REFER(
          {
            ...prop,
            ...queryParams(source),
            type: type,
          },
          {
            pageNum,
            pageSize,
          }
        );
        if (code === 200) {
          this.data = rows;
          this.page.total = total;
        }
      } catch (err) {
        // catch
        console.error(err);
      } finally {
        // finally
        this.loading = false;
      }
    },
    // reset
    async useReset() {
      this.data = [];
      this.page.pageNum = 1;
      this.page.pageSize = 10;
      this.model.search = null;
      await this.fetchList(this.model, this.page);
    },
    // query
    async useQuery() {
      await this.fetchList(this.model, this.page);
    },
    // auto
    async useAutocomplete(prop, cb) {
      if (prop) {
        this.page.pageSize = 25;
        this.model.search = prop;
        await this.fetchList(this.model, this.page);
        await cb(this.data);
      } else {
        cb([]);
      }
    },
    // select
    useSelect(prop) {
      this.selectData = prop[0];
    },
    // confirm
    useConfirm(prop) {
      this.hide();
      const {
        $props: { source, valueKey, dataMapping },
      } = this;
      for (let key in dataMapping) {
        source[key] = prop[dataMapping[key]];
      }
      this.innerValue = prop[valueKey];
      this.$emit("update:source", source);
      this.$emit("change", prop, this.$props);
    },
  },
  created() {},
  mounted() {},
  destroyed() {},
};
</script>

<template>
  <div class="popover-select-v2">
    <el-autocomplete
      v-bind="$attrs"
      v-model="innerValue"
      :value-key="valueKey"
      :fetch-suggestions="useAutocomplete"
      @select="useConfirm"
      style="width: 100%"
    >
      <i class="el-icon-search" slot="suffix" @click="open"> </i>
      <template slot-scope="{ item }">
        <p
          style="
            text-overflow: ellipsis;
            overflow: hidden;
            line-height: 15px;
            margin: 5px 0;
          "
        >
          {{ item.name }}
        </p>
        <p
          style="
            font-size: 12px;
            color: #b4b4b4;
            line-height: 15px;
            margin: 5px 0;
          "
        >
          {{ item.code }}
        </p>
      </template>
    </el-autocomplete>
    <el-dialog
      :width="width"
      :visible.sync="visible"
      :close-on-click-modal="false"
      :close-on-press-escape="false"
      append-to-body
    >
      <div slot="footer">
        <el-button
          type="primary"
          :size="$attrs.size"
          :loading="loading"
          @click="useConfirm(selectData)"
          >确 认</el-button
        >
        <el-button :size="$attrs.size" :loading="loading" @click="hide"
          >取 消</el-button
        >
      </div>
      <el-form
        v-loading="loading"
        :size="size"
        :inline="true"
        :model="model"
        @submit.native.prevent
      >
        <el-form-item prop="search">
          <el-input
            v-model="model.search"
            @change="useQuery"
            @keydown.enter="useQuery"
          >
          </el-input>
        </el-form-item>
        <el-form-item>
          <el-button icon="el-icon-refresh" @click="useReset"></el-button>
        </el-form-item>
        <el-table
          :data="data"
          :size="size"
          height="45vh"
          highlight-current-row
          @row-dblclick="useConfirm"
          @row-click="useSelect([$event])"
        >
          <el-table-column
            v-for="(column, index) in TableColumns"
            :key="index"
            :prop="column.key"
            :label="column.title"
            :width="column.width || 'auto'"
            show-overflow-tooltip
          >
            <template slot-scope="scope">
              <dr-computed-input
                v-if="column.type === 'ComputedInput'"
                v-model="scope.row[column.key]"
                :source="scope.row"
                :formatter="column.formatter"
                :placeholder="column.placeholder"
                style="width: 100%"
              ></dr-computed-input>
              <span v-else> {{ scope.row[column.key] }}</span>
            </template>
          </el-table-column>
        </el-table>
        <pagination
          v-show="!loading"
          :total="page.total"
          :page.sync="page.pageNum"
          :limit.sync="page.pageSize"
          @pagination="useQuery"
        />
      </el-form>
    </el-dialog>
  </div>
</template>
<style scoped>
.popover-select-v2 .el-autocomplete {
  width: inherit;
}
.popover-select-v2 .el-autocomplete .el-icon-search {
  cursor: pointer;
}
::v-deep .el-table--mini .el-table__cell {
  height: 50px;
}
</style>
